// This software was written by Gregory L Montgomery
// and is completely covered by the 
// GPL General Public License

// Date of release 1/7/1998 

// Programmer Gregory Montgomery

// This is the .C file for the AD  CLASS


#include <iostream.h>
#include <ctype.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include "ad.h"
#include "ADC0804.h"

// This is an abstract class

// ----------------------------------------------------------- */
// constructors                                                */
// Default AD0804 

mADC0804::mADC0804():AD(){

    //strcpy(ID,"mADC0804");
    Lower = new double[16];
    Upper = new double[16];
        Lower[0]  = 0;
        Lower[1]  = 1.0/256.0; 
        Lower[2]  = 1.0/128.0;
        Lower[3]  = 3.0/256.0;
        Lower[4]  = 1.0/64.0;
        Lower[5]  = 2.0/256.0;
        Lower[6]  = 3.0/128.0;
        Lower[7]  = 7.0/256.0;
        Lower[8]  = 1.0/32.0;
        Lower[9]  = 9.0/256.0;
        Lower[10] = 5.0/128.0;
        Lower[11] = 11.0/256.0;
        Lower[12] = 3.0/64.0;
        Lower[13] = 13.0/256.0;
        Lower[14] = 7.0/128.0;
        Lower[15] = 15.0/256.0;
        Upper[0]  = 0;
        Upper[1]  = 1.0/16.0;
        Upper[2]  = 1.0/8.0;
        Upper[3]  = 3.0/16.0;
        Upper[4]  = 1.0/4.0;
        Upper[5]  = 5.0/16.0;
        Upper[6]  = 3.0/8.0;
        Upper[7]  = 7.0/16.0;
        Upper[8]  = 1.0/2.0;
        Upper[9]  = 9.0/16.0;
        Upper[10] = 5.0/8.0;
        Upper[11] = 11.0/16.0;
        Upper[12] = 3.0/4.0;
        Upper[13] = 13.0/16.0;
        Upper[14] = 7.0/8.0;
        Upper[15] = 15.0/16.0;



}

// Default AD0804 

mADC0804::mADC0804(int Port):AD(Port){

    //strcpy(ID,"mADC0804");
    Lower = new double[16];
    Upper = new double[16];
        Lower[0]  = 0;
        Lower[1]  = 1.0/256.0; 
        Lower[2]  = 1.0/128.0;
        Lower[3]  = 3.0/256.0;
        Lower[4]  = 1.0/64.0;
        Lower[5]  = 2.0/256.0;
        Lower[6]  = 3.0/128.0;
        Lower[7]  = 7.0/256.0;
        Lower[8]  = 1.0/32.0;
        Lower[9]  = 9.0/256.0;
        Lower[10] = 5.0/128.0;
        Lower[11] = 11.0/256.0;
        Lower[12] = 3.0/64.0;
        Lower[13] = 13.0/256.0;
        Lower[14] = 7.0/128.0;
        Lower[15] = 15.0/256.0;
        Upper[0]  = 0;
        Upper[1]  = 1.0/16.0;
        Upper[2]  = 1.0/8.0;
        Upper[3]  = 3.0/16.0;
        Upper[4]  = 1.0/4.0;
        Upper[5]  = 5.0/16.0;
        Upper[6]  = 3.0/8.0;
        Upper[7]  = 7.0/16.0;
        Upper[8]  = 1.0/2.0;
        Upper[9]  = 9.0/16.0;
        Upper[10] = 5.0/8.0;
        Upper[11] = 11.0/16.0;
        Upper[12] = 3.0/4.0;
        Upper[13] = 13.0/16.0;
        Upper[14] = 7.0/8.0;
        Upper[15] = 15.0/16.0;
}


//-----------------------------------------------------------/
// destructor Virtual : Every class that inherits from 
// this will have to declare a destructor like to or not 

mADC0804::~mADC0804(){
     delete []Lower;
     delete []Upper;
}

//-----------------------------------------------------------
// This is a basic clone function

AD * mADC0804::clone()const{return new mADC0804 (*this);}


//--------------------------------------------------------------
// A virtual kind function

AD::Types mADC0804::kind() const {
    return ((AD::Types) ADC);
}

//----------------------------------------------------------------/
// This will generically allow us to ID which type of AD
// we are dealing with

char * mADC0804::Ident()const{
    return "ADC";
} 

//---------------------------------------------------------
// Resets the AD Converter

void mADC0804::Reset(){Mux.Reset();}

//--------------------------------------------------------
// This is the Fuction that dose the convertion for us

double mADC0804::Volts()const{

        double Sum;
        unsigned char Stc,Lr,Upr;
        int k;

        read(AD_Port, &Stc, 1);
        Sum = 0;
        for(k = 0; k < 10; k++){
             read(AD_Port, &Stc, 1);
             Lr = Stc & 15;
             Upr = Stc >> 4;
             Sum += VRef * Upper[Upr] + VRef * Lower[Lr];
        }
        return Sum/(double)k;
}

void mADC0804::Port(int const PortNo){Mux.Select(PortNo);}
